/* 
 * Autor:             Alexander Gossen
 * Modul:             Masterarbeit
 * Projekt:           Medizinstation
 * Bemerkung:         Hauptprogramm des Projektes Medizinstation
 * Letzte Änderung:   31.10.21
*/

#include "Medizinstation_Setup_Variablen.h"     // Eigene Headerdatei 'Medizinstation_Setup_Variablen.h' einbinden
#include "Pulsmessung_Funktionen.h"             // Eigene Headerdatei 'Pulsmessung_Funktionen.h' einbinden

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////// AB HIER KANN DER CODE VERÄNDERT WERDEN ///////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

int grenzwert = 6000;                            // Grenzwert, ab dem die LED später leuchten soll (muss an die Beleuchtung im Raum angepasst werden)

int stopzeit = 10000;                           // Bestimmt,in welchem Zeitraum Herzschläge aufgezeichnet werden sollen (hier 10 Sekunden)

void loop() {


  intervallMessung();                           // Nur alle 20 Millisekunden soll ein Wert gemessen werden (Rauschunterdrückung)

  messungGlaetten();                            // Messkurve glätten

  // Signale plotten
  sensorwert = analogRead(pulssensor);         // Die Werte des Pulssensors werden in der Variable sensorwert gespeichert  
  Serial.print(mittelwert);                    // Der Wert des Mittelwerts wird im seriellen Monitor ausgegeben (auch notwendig für den seriellen Plotter)
  Serial.print(",");                           // Das Komma dient zur Darstellung unterschiedlicher Variablen oder Werte im seriellen Plotter
  Serial.println(sensorwert);                  // Das unverarbeitete Signal wird im seriellen Monitor ausgegeben
  delay(60);                                   // Das Programm kann für 10 Millisekunden angehalten

   //Berechnung des Herzschlags pro Minute
  if (mittelwert > grenzwert){                  // Prüfe, ob der Wert des Pulssensors größer als eine selbst festgelegte Zahl ist in der Variable 'grenzwert'...
    
    tone(lautsprecher, 1000);                   // Der Lautsprecher wird mit der Frequenz 300 für eine Dauer für von 500 Millisekunden aktiviert
    
    for (i = 250; i > 10; i = i - 1){            // An dieser Stelle wiederholt sich das Programm solange wie die Bedingung definert wurde
      
      analogWrite(led_rot, i);                  // Die LED wird dem Puls entsprechend gedimmt
      
      delay(0.9);                                 // Das Programm wird für 10 Millisekunden angehalten

    }
    
    zaehler = zaehler + 1;                      // Jedes mal wenn der Sensorwert größer als der Grenzwert ist wird die Variable zaehler um eins erhöht
    
  }
  
  else {                                       // Wenn der Sensorwert nicht größer als der Grenzwert ist...
    
     analogWrite(led_rot, 0);                  // Die LED wird leuchtet nicht
     
     noTone(lautsprecher);                     // Der Lautsprecher wird nicht aktiviert
    
  }

  // Berechnung des Herzschlags
  timer = millis();                          // Der ersten Zeit-Variable wird die millis()-Funktion zugewiesen. In der Variable wird von nun an die Zeit 
                                               // in Millisekunden gezählt
  if (timer - timer2 > stopzeit){              // Prüfe, ob die erste Zeit-Variable minus der zweiten Zeit-Variable größer als der vorgegebene Wert in der
                                               // Variable 'stopzeit' ist...    
    timer2 = timer;                            // Die zweite Zeit-Variable nimmt den Wert der ersten Zeit-Variable an

    bpm = zaehler * 6;                         // Berechnung des Herzschlags pro Minute

    zaehler = 0;                               // Die Variable zaehler wird auf null gesetzt damit das Programm die Anzahl der Herzschläge in zehn Sekunden 
                                               // erneut messen kann um daraus den Puls zu berechnen
  }

  // Pulsfrequenz auf dem LCD-Bildschirm anzeigen (kommentierung aufheben zum aktivieren)
//  lcd.setCursor(0, 0);                         // Hier wird die Position des ersten Zeichens festgelegt. (0,0) bedeutet, das erste Zeichen in der ersten Zeile.
//  lcd.print("BPM:");                           // In der ersten Zeile und in der ersten Stelle des Bildschirms wird das Wort 'BPM:' (Beats Per Minute) ausgegeben
//  lcd.setCursor(4, 0);                         // (4, 0) bedeutet das der Cursor auf die vierte Stelle in der ersten Zeile des Bildschirms gesetzt wird
//  lcd.print(bpm);                              //  An der Stelle (4, 0) wird der Pulswert ausgegeben
//  lcd.setCursor(7, 0);                         //  Der Cursor wird auf die siebte Stelle in der ersten Zeile des Bildschirms gesetzt
//  lcd.print("  ");                             //  Danach werden leerzeichen ausgegeben um den vorher angezeigten Wert zu löschen

}
