/* 
 * Autor:             Alexander Gossen
 * Modul:             Masterarbeit
 * Projekt:           Medizinstation
 * Bemerkung:         Ergänzung zum Projekt Medizinstation. Enthält den Setup-Block und die wichtigsten Variablen.
 * Letzte Änderung:   01.11.21
*/

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////// HIER NICHTS ÄNDERN ///////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include <Wire.h>                             // Wire Bibliothek einbinden (Notwendig für die I2C-Schnittstelle des LCD-Bildschirms)
#include <LiquidCrystal_I2C.h>                // Bibliothek für das LCD-Bildschirm einbinden
LiquidCrystal_I2C lcd(0x27, 16, 2);           // Hier wird festgelegt um was für einen Display es sich handelt. In diesem Fall eines mit 16 Zeichen in 2 Zeilen und der HEX-Adresse 0x27. Für ein vierzeiliges I2C-LCD verwendet man den Code "LiquidCrystal_I2C lcd(0x27, 20, 4)"

const int messungen = 20;                     // Definiert die Größe des Arrays
int messungen_array[messungen];               // Array für die Messwerte des Pulssensors
int index = 0;                              // Laufvariable für das Array
double summe = 0;                             // Addiert die einzelnen Messwerte auf bis 'index' > 19 ist
double mittelwert = 0;                        // Variable zur Berechnung des Mittelwertes aus 20 Messwerten

int pulssensor = A0;                          // Signalleitung an Analog A0
int led_rot = 6;                              // LED an Port 6 wird verwendet
int lautsprecher = 7;                         // Dem Lautsprecher wird der digitale Port 7 zugewiesen

int bpm = 0;                                  // Gibt den Wert des Pulses als Zahl wieder
int zaehler = 0;                              // Zählt die Herzschläge in einem definierten Intervall (zwischen 'timer1' und 'timer2')
int timer = 0;                                // Erster Timer (beginnt zu zählen sobald der grenzwert das erste mal überschritten oder unterschritten wurde)
int timer2 = 0;                               // Zweiter Timer

int sensorwert;                            // Variable für den Sensworwert des Pulssensors

int i;                                        // Laufvariable für die LED (zur Simulation einer Dimmung mit PWM)
int n = 0;                                    // Variable, welche es ermöglicht alle 20 Millisekunden einen Messwert aufzunehmen                       
int l = 0;                                    // Zählt die aufgenommenen Messwerte in 20 Millisekunden                  
long aktuelle_zeit;                           // Timer-Variable, um die 20 Millisekunden zu messen  

  void setup() {

  Serial.begin(9600);                         // Starten des Seriellen Monitors
  
  delay(10);                                  // 10 Millisekunden warten
  
  lcd.init();                                 // LCD-Bildschirm initialisieren
  lcd.backlight();                            // Die Hintergrundbeleuchtung des LCD-Bildschirms aktivieren
  lcd.clear();                                // Jegliche Ausgabe auf dem Bildschirm löschen

  lcd.setCursor(0, 0);                        // Den Cursor in die erste Zeile und an die erste Stelle setzen
  lcd.print("                ");              // Leerzeichen Ausgeben um bis hierhin eventuell auftretende Zeichen zu löschen
  lcd.setCursor(0, 1);                        // Den Cursor in die zweite Zeile und an die erste Stelle setzen
  lcd.print("                ");              // Leerzeichen Ausgeben um bis hierhin eventuell auftretende Zeichen zu löschen

  pinMode(led_rot, OUTPUT);                   // Pin 6 ist ein Ausgang, damit die LED mit Spannung versorgt wird

  for (int j = 0;j < messungen;j++){          // Das Array mit Messwerten für den Pulssensor wird mit nullen initialisiert

    messungen_array[j] = 0; 
    
  }

  Serial.println("Gefiltert: ,Rohsignal: ");  // Legende für den seriellen Plotter für zwei unterschiedliche Kurven

}
